import * as vscode from 'vscode';
import { IPythonTerminal } from '../pythonTerminal';
import { IOptionsBuilder, IPackageRunner } from './types';
import { PackageInfo } from '../types';
/**
 * Runs Python package.
 */
export declare class PackageRunner implements IPackageRunner {
    private terminal;
    private installationTerminalProvider;
    private optionsBuilder;
    private packageInfo;
    /**
     * @param terminal Terminal to run package in.
     * @param optionsBuilder Options builder to build options for the package.
     * @param packageInfo Package information.
     * @param installationTerminalProvider Function to get a terminal to install the package in if it is not installed.
     */
    constructor(terminal: IPythonTerminal, optionsBuilder: IOptionsBuilder, packageInfo: PackageInfo, installationTerminalProvider?: () => Promise<IPythonTerminal>);
    /**
     * Run package for the uris based on the configuration. If package is not installed, show a prompt to install.
     * @param uris File paths and folder paths to run package for.
     */
    run(uris: vscode.Uri[]): Promise<void>;
}
